<template>
  <page>
    <a-form
      class="section-form"
      @submit="handleSubmit"
    >
      <h1>Preencha os dados da seção</h1>
      <a-form-item
        label="Título da seção"
        class="input-icon"
        required="true"
      >
        <a-input
          v-model="title"
          placeholder="Digite o título da seção"
          type="text"
          :maxlength="titleLimit"
          required="true"
        />
        <p>{{ titleLimit - title.length }} caracteres restantes</p>
      </a-form-item>

      <a-form-item
        label="Conteúdo da seção"
        class="input-icon"
        required="true"
      >
        <v-editor
          :clear-content="clearContent"
          @content-changed="handleContentChanged"
        />
      </a-form-item>

      <a-form-item>
        <a-button
          html-type="submit"
          type="primary"
          class="submit-button"
          :disabled="uploading"
        >
          <span v-if="uploading">
            <a-icon type="loading" />
          </span>
          <span v-else>Enviar</span>
        </a-button>
      </a-form-item>
    </a-form>
  </page>
</template>

<script>
import VEditor from '@/components/VEditor.vue';
import editorContent from '@/mixins/editor';
import axios from 'axios';

export default {
  name: 'News',
  components: {
    VEditor,
  },
  mixins: [editorContent],
  data() {
    return {
      title: '',
      uploading: false,
      titleLimit: 45,
    };
  },
  methods: {
    async handleSubmit(e) {
      e.preventDefault();
      if (this.checkFields()) {
        try {
          this.uploading = true;

          const ENDPOINT = 'http://api.institutoholistico.com.br/sections';
          const formData = this.createFormData();

          await axios({
            method: 'POST',
            url: ENDPOINT,
            headers: {
              'Content-type': 'application/json; charset=utf-8',
              Accept: 'application/json; charset=utf-8',
              'x-access-token': localStorage.getItem('@jw-ih-t'),
            },
            data: formData,
          });

          this.$message.success('Seção adicionada com sucesso.');

          this.clearFields();
          this.uploading = false;
        } catch (error) {
          this.uploading = false;
          this.$message.error('Ocorreu um erro ao tentar adicionar a seção. Tente novamente mais tarde.');
        }
      } else {
        this.$message.error('Por favor preencha todos os dados obrigatórios!');
      }
    },
    checkFields() {
      return this.title && this.content;
    },
    createFormData() {
      const formData = {
        text: this.title,
        content: this.content,
        active: true,
      };

      return formData;
    },
    clearFields() {
      this.title = '';
      this.clearEditorContent();
    },
  },
};
</script>

<style lang="stylus" scoped>
.submit-button
  float right
</style>
